class Nbody_ascii(NbodyDefault):
  
  def get_read_fcts(self):
    return [self.read_particles]
    
  def get_write_fcts(self):
    return [self.write_particles]    
    
  def get_spec_vars(self):
    '''
    return specific variables default values for the class
    '''
    return {'tnow'   :0.,
	    }

  def read_particles(self,f):
    '''
    read binary particle file
    '''
      
      
    lines = f.readlines()  
    lines = map(string.strip, lines)
    elts = map(string.split,lines)
    
    #x = array(map(lambda x:float(x[0][:-1]),elts))
    #y = array(map(lambda x:float(x[1][:-1]),elts))    
    #z = array(map(lambda x:float(x[2][:-1]),elts))   
     
    #vx = array(map(lambda x:float(x[3][:-1]),elts))
    #vy = array(map(lambda x:float(x[4][:-1]),elts))
    #vz = array(map(lambda x:float(x[5][:-1]),elts))     
    
    x = array(map(lambda x:float(x[0]),elts))
    y = array(map(lambda x:float(x[1]),elts))  
    z = array(map(lambda x:float(x[2]),elts))  
    
    try:
      vx = array(map(lambda x:float(x[3]),elts))
      vy = array(map(lambda x:float(x[4]),elts))
      vz = array(map(lambda x:float(x[5]),elts)) 
    except:
      vx = zeros(len(x))  
      vy = zeros(len(x))  
      vz = zeros(len(x))  
    
     
    f.seek(0,2)	   
    pos = transpose(array([x,y,z]))	   
    pos = pos.astype(Float32)			   
    vel = transpose(array([vx,vy,vz]))	   
    vel = vel.astype(Float32)
        
    # make global
    self.tnow  = 0.
    self.nbody = len(pos)
    
    self.pos = pos
    self.vel = vel
    

  def write_particles(self,f):
    '''
    specific format for particle file
    '''
    for i in range(self.nbody):	     
     line = "%10.5f %10.5f %10.5f %10.5f %10.5f %10.5f \n" %(self.pos[i][0],self.pos[i][1],self.pos[i][2],self.vel[i][0],self.vel[i][1],self.vel[i][2])
     f.write(line)     
